import random, graphicsclass, math, packageclass
from constants import *

class world:
	def __init__(self, graphics):
		self.world = []
		self.ceiling = [0]
		random.seed(None)
		
		
		self.world.append (random.randint(500, windowSize[1]))
		for i in range(1,worldsize):
			a = self.world[i-1]
			b = a + random.randint(0, 50)-25
			if b < 400:
				b = 400
			if b > windowSize[1]:
				b = windowSize[1]
			self.world.append (b)
		for i in range(1,int(math.ceil(worldsize/float(30)))):
			z = i * 30
			self.world[z] = self.world[z-1]
		
		for i in range(1,worldsize):
			a = random.randint(0,15)
			b = 0
			if a < 1:	#give a 1 in 15 chance
				b = random.randint(0,self.world[i]-300) #give a minimum distance of 300 between floor and ceiling
				self.ceiling[i-1] = b + random.randint(0,50)-25
			self.ceiling.append(b)
			
		self.packages = []
		for i in range(100):
			self.packages.append(packageclass.package())
		self.packagesonscreen = []
		graphics.load('landing.bmp','landpad',True,(0,0,0))
		for i in self.packages[:]:
			if (i.pickuppoint > 50950-3000) and i.pickuppoint < 50950+3000:
				self.packages.remove(i)

		for i in range(3):
			self.packages.append(packageclass.package(50950+(i+1)*400,51950+(i+1)*400, ((i+1)**2)*10, 100, 100))
			self.packages.append(packageclass.package(50950-(i+1)*400,49950-(i+1)*400, ((i+1)**2)*10, 100, 100))			

	def draw(self, graphics, xposition):
		low = (xposition - halfwindowsize[0]) / 100
		high = (xposition + halfwindowsize[0]) / 100

		vertlist = []
		vertlist2 = []
		tr = False
		for i in range(int(low-1),int(high+2)):
			if (i < worldsize) and (i >= 0):
				vertlist.append(((i-low)*100,self.world[i]))
				vertlist2.append(((i-low)*100,self.ceiling[i]))
				
		if tr == True:
			vertlist.append((windowSize[0],0))
		vertlist.append(windowSize)	#now go to bottom right corner
		vertlist.append((0, windowSize[1])) #and bottom left, to fill it all in
		vertlist2.append((windowSize[0],0))	#and for the cieling go top right- top left
		vertlist2.append((0,0))
		
		graphics.drawpoly(vertlist, (0, 255, 0))
		graphics.drawpoly(vertlist2, (0, 255, 0), )
		
		for i in range(int(low-2),int(high+2)):
			if i > 0 and i < worldsize:
				if i%30 ==0:
					graphics.draw('landpad', ((i-1 - low)*100,self.world[i]-40))
				
		
		self.packagesonscreen = []
		for each in self.packages:
			if each.state == 0:
				if each.pickuppoint > (xposition - halfwindowsize[0] - 25) and each.pickuppoint < (xposition + halfwindowsize[0] + 25):
					self.packagesonscreen.append(each)
					x = each.pickuppoint - xposition + halfwindowsize[0]
					y = self.checkfloor(each.pickuppoint)
					graphics.draw('crate', (x-25, y-25))
					graphics.write('info', 'Distance: '+str(abs(each.droppoint - each.pickuppoint)), (x,y-80),(255,255,255))
					graphics.write('info', 'Mass: '+str(each.mass), (x,y-65),(255,255,255))
					graphics.write('info', 'Strength: '+str(each.strength), (x,y-50),(255,255,255))
					graphics.write('info', 'Reward: '+str(each.price), (x,y-35),(255,255,255))
					
					
		
		
	def checkfloor(self, x):
		pos = int(x//100)
		mid = x - (pos*100)
		return int(self.world[pos] + ((self.world[pos+1] - self.world[pos])*(mid/100.0)))
	
	def checkceil(self, x):
		pos = int(x//100)
		mid = x - (pos*100)
		return int(self.ceiling[pos] + ((self.ceiling[pos+1] - self.ceiling[pos])*(mid/100.0)))
	
	def islandingpad(self, x):
		pos = int(x//100)+1
		#print pos
		if pos % 30 == 0:
			result = True
		else:
			result = False
		return result
		
	def getprojection(self, pos):
		z1 = int(pos[0] // 100)
		z2 = z1 + 1
		v1 = (z1 * 100, self.world[z1])
		v2 = (z2 * 100, self.world[z2])
		vect = (v2[0] - v1[0], v2[1]-v1[1])
		norm = (-vect[1],vect[0])
		pos2 = [0,0]
		pos2[0] = pos[0] + norm[0]
		pos2[1] = pos[1] + norm[1]
		#ok, now we have two points for each line (v1, v2 are the points on the world, pos and pos2 are the points of our line)
		#so we get the coefficients A B and C for each line:
		A1 = v2[1]-v1[1]
		B1 = v1[0]-v2[0]
		C1 = A1*v1[0]+B1*v1[1]
		
		A2 = pos2[1]-pos[1]
		B2 = pos[0]-pos2[0]
		C2 = A2*pos[0]+B2*pos[1]
		
		#we know that these lines are perpendicular so det can't be 0, no worries
		det = A1*B2 - A2*B1
		point = ((B2*C1 - B1*C2)/det,(A1*C2 - A2*C1)/det)
		return point	#hopefully this is the projection point
		
	def GetCeilProjection(self, pos):
		z1 = int(pos[0] // 100)
		z2 = z1 + 1
		v1 = (z1 * 100, self.ceiling[z1])
		v2 = (z2 * 100, self.ceiling[z2])
		vect = (v2[0] - v1[0], v2[1]-v1[1])
		norm = (-vect[1],vect[0])
		pos2 = [0,0]
		pos2[0] = pos[0] + norm[0]
		pos2[1] = pos[1] + norm[1]
		#ok, now we have two points for each line (v1, v2 are the points on the ceiling, pos and pos2 are the points of our line)
		#so we get the coefficients A B and C for each line:
		A1 = v2[1]-v1[1]
		B1 = v1[0]-v2[0]
		C1 = A1*v1[0]+B1*v1[1]
		
		A2 = pos2[1]-pos[1]
		B2 = pos[0]-pos2[0]
		C2 = A2*pos[0]+B2*pos[1]
		
		#we know that these lines are perpendicular so det can't be 0, no worries
		det = A1*B2 - A2*B1
		point = ((B2*C1 - B1*C2)/det,(A1*C2 - A2*C1)/det)
		return point	#hopefully this is the projection point
